<?php
wp_unslash($_SERVER['SCRIPT_FILENAME']);
if ( isset($_SERVER['SCRIPT_FILENAME']) && realpath(__FILE__) == realpath($_SERVER['SCRIPT_FILENAME'])) {
    exit('Please don\'t access this file directly.');
}

class OEPL_Lead_Widget extends WP_Widget {
	function __construct() 
	{
		parent::__construct(
			'OEPL_Lead_Widget', 
			__('SugarCRM Lead Form', 'OEPL_Lead_Widget'), 
			array( 'description' => __( 'This Widget will submit data into your SugarCRM Lead module.', 'WPBeginner Widget' ), ) 
		);
	}

	public function widget( $args, $instance ) 
	{
		
		
		global $wpdb;
		$query = "SELECT * FROM ".OEPL_TBL_MAP_FIELDS." WHERE is_show = 'Y' ORDER BY display_order ASC";
		$RS = $wpdb->get_results($query,ARRAY_A);
		
		if(isset($instance['OEPL_Widget_Title'])){
			$title = apply_filters( 'widget_title', $instance['OEPL_Widget_Title'] );
		}

		echo $args['before_widget'];
		if ( ! empty( $title ) )
			echo $args['before_title'] . $title . $args['after_title'];
			$Custom_CSS = get_option("OEPL_Form_Custom_CSS");
		
		if($Custom_CSS && $Custom_CSS != ''){
			echo '<style type="text/css">'.$Custom_CSS.'</style>';
		}
		
		echo "<p><div class='LeadFormMsg' style='color:red'></div></p>";
		echo "<form id='OEPL_Widget_Form' method='POST' enctype='multipart/form-data'>";
		echo "<input type='hidden' value='".wp_create_nonce( 'upload_thumb' )."' name='_nonce' />";
  		echo '<input type="hidden" name="action" id="action" value="WidgetForm">';
		foreach ($RS as $module)
		{
			if($module['hidden'] == 'N')
			{
				### Add Date picker Class if filed type match
				if($module['data_type'] == 'date'){
					$JQclass = 'DatePicker nonHidden';
					$readonly = 'readonly';
				} else if($module['data_type'] == 'datetimecombo') {
					$JQclass = 'DateTimePicker nonHidden';
					$readonly = 'readonly';
				} else if($module['data_type'] == 'file') {
					$JQclass = 'files nonHidden';
					$readonly = '';
				} else {
					$readonly = '';
					$JQclass = 'nonHidden';
				}
				### Add required class if reqiured is true
				if($module['required'] === 'Y'){
					$JQclass .= ' LeadFormRequired';
					$LabelAsterisk = ' <span style="color: red">*</span>';				
				} else {
					$LabelAsterisk = '';
				}
				### Display Custom label if is set
				if($module['wp_custom_label'] && $module['wp_custom_label'] != ''){
					$label = $module['wp_custom_label'].$LabelAsterisk;
				} else {
					$label = $module['wp_meta_label'].$LabelAsterisk;
				}
				echo "<p>";
				echo "<label><strong>".$label." :</strong></label><br>";
				echo wtsl_getHTMLElement($module['field_type'],$module['wp_meta_key'],$module['field_value'],$module['field_value'],'',$JQclass,$readonly);
				echo "</p>";
			} else {
				if(isset($instance[$module['field_name']])){
					echo '<input type="hidden" class="LeadFormEach" name="'.$module['wp_meta_key'].'" value="'.$instance[$module['field_name']].'" />';
				}
			}
		}

		$captchaSettings = get_option('OEPL_Captcha_status');
		$oepl_sel_captcha = get_option('OEPL_Select_Captcha');
	
		
		if($captchaSettings == 'Y')
		{
			if($oepl_sel_captcha == 'google')
			{
				echo "<script src='https://www.google.com/recaptcha/api.js?onload=gReCaptcha&render=explicit' async defer></script>";
			
				echo '<script>
						var reCAPTCHA_key = \''.get_option('OEPL_RECAPTCHA_SITE_KEY').'\';
					</script>';
							  
				echo '<p><div class="g-recaptcha" id="grecaptcha" data-sitekey=""></div></p>';	
			
			}else{
			
				echo '<p class="OEPL_captcha"><img src="'.OEPL_PLUGIN_URL.'captcha.php?t='.$sess_time.'" title="captcha" class="OEPL_captcha_img"/><img src="'.OEPL_PLUGIN_URL.'image/reload_captcha.png" title="Reload Captcha" class="OEPL_repload_captcha"/></p>';
			
				echo "<p><label><strong>Enter Verification Code :</strong></label><input type='text' name='captcha' id='OEPL_CAPTCHA' maxlength='5' class='LeadFormRequired'/></p>";
			}
		}
		
		if(count($RS) > 0 )
		{
			echo "<p><input type='submit' name='submit' style ='' value='Submit' id='WidgetFormSubmit' class='' ></p>";
		}
			
		echo "</form>";
		
		echo "<script>
				var gReCaptcha = function() {
					jQuery('.g-recaptcha').each(function(){
						grecaptcha.render(this, {
					        'sitekey' : reCAPTCHA_key, 
						});
					});
				}
			</script>";
		echo $args['after_widget'];
	}
			
	public function form( $instance ) 
	{
		global $wpdb;
		if ( isset( $instance[ 'OEPL_Widget_Title' ] ) ) {
			$title = $instance[ 'OEPL_Widget_Title' ];
		} else {
			$title = __( 'New title', 'wpb_widget_domain' );
		}
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'OEPL_Widget_Title' ); ?>"><?php _e( 'Title:' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'OEPL_Widget_Title' ); ?>" name="<?php echo $this->get_field_name( 'OEPL_Widget_Title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		
		<?php
		$query = "SELECT * FROM ".OEPL_TBL_MAP_FIELDS." WHERE is_show = 'Y' AND hidden='Y' AND custom_field = 'N' ORDER BY display_order ASC";
		$RS = $wpdb->get_results($query,ARRAY_A);
		if(count($RS) > 0)
		{
			echo '<div align="center"><h4>Hidden Attributes</h4></div><hr />';
		}
		foreach($RS as $field){
			if ( isset( $instance[$field['field_name']] ) ) {
				$FieldVal = $instance[$field['field_name']];
			} else {
				$FieldVal = '';
			}
			if($field['data_type'] == 'date'){
				$JQclass = 'DatePicker widefat';
				$extra = 'readonly';
			} else if($field['data_type'] == 'datetimecombo') {
				$JQclass = 'DateTimePicker widefat';
				$extra = 'readonly';
			} else {
				$extra = '';
				$JQclass = 'widefat';
			}
			echo "<p>";
			echo "<label>".$field['wp_meta_label']."</label>";
			echo wtsl_getHTMLElement($field['field_type'],$this->get_field_name($field['field_name']),$field['field_value'],$FieldVal,'',$JQclass,$extra);
			echo "</p>";
		} 
	}
	
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		foreach($new_instance as $key=>$val)
		{
			$instance[$key] = (!empty($val)) ? strip_tags($val) : '';
		}
		return $instance;
	}
} 

function OEPL_Lead_Widget_init() {
	session_start();
	register_widget( 'OEPL_Lead_Widget' );
}
add_action( 'widgets_init', 'OEPL_Lead_Widget_init' );

function wtsl_WidgetFormJS(){
	echo "<script>
		  	var ajaxurl = '".admin_url( 'admin-ajax.php', 'relative' )."';
		  	var ReqFieldMsg = '".get_option('OEPL_SugarCRMReqFieldsMessage')."';
		  	var OEPL_PLUGIN_URL = \"".OEPL_PLUGIN_URL."\";
		  </script>";
		echo "<style>
			    .InvalidInput{
					border-color: red !important;
			    }
			  </style>";
}
add_action('wp_footer', 'wtsl_WidgetFormJS');

add_shortcode('OEPL_CRM_Lead_Form', 'OEPL_CRM_Lead_Form');
function OEPL_CRM_Lead_Form($atts, $content = null)
{
	ob_start();
    the_widget('OEPL_Lead_Widget', 
    	array(
	        'before_widget' => '',
	        'after_widget' => '',
	        'before_title' => '',
	        'after_title' => ''
    	)
	);
    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}
?>