﻿<?php

wp_unslash($_SERVER['SCRIPT_FILENAME']);
if ( isset($_SERVER['SCRIPT_FILENAME']) && realpath(__FILE__) == realpath(sanitize_file_name($_SERVER['SCRIPT_FILENAME']))) {
	exit('Please don\'t access this file directly.');
}

$htaccessProtected = get_option('OEPL_is_SugarCRM_htaccess_Protected');
$htaccessUsername = get_option('OEPL_SugarCRM_htaccess_Username');
$htaccessPassword = get_option('OEPL_SugarCRM_htaccess_Password');

$successMsg = get_option('OEPL_SugarCRMSuccessMessage');
$failureMsg = get_option('OEPL_SugarCRMFailureMessage');
$ReqFieldsMessage = get_option('OEPL_SugarCRMReqFieldsMessage');
$InvalidCaptchaMessage = get_option('OEPL_SugarCRMInvalidCaptchaMessage');

$IPaddrStatus = get_option('OEPL_auto_IP_addr_status');
$EmailNotification = get_option('OEPL_Email_Notification');
$EmailNotificationRx = get_option('OEPL_Email_Notification_Receiver');
$redirectStatus = get_option("OEPL_User_Redirect_Status");
$redirectTo = get_option("OEPL_User_Redirect_To");
$captchaSettings = get_option('OEPL_Captcha_status');
$sel_captcha = get_option('OEPL_Select_Captcha');

if ($EmailNotification == 'Y')
	$Email_checked = 'checked="checked"';
else
	$Email_checked = '';
if ($IPaddrStatus == 'Y')
	$IP_checked = 'checked="checked"';
else
	$IP_checked = '';
if ($redirectStatus == 'Y')
	$redirectCbx = 'checked="checked"';
else
	$redirectCbx = '';
if ($htaccessProtected == 'Y')
	$htacessCbx = 'checked="checked"';
else
	$htacessCbx = '';

wp_unslash($_GET);
if (isset($_GET['view']) && !$_GET['view'] OR !isset($_GET['view']) OR empty($_GET['view'])) {
	$_GET['view'] = 'sugarSettings';
}

?>
<div class="wrap">
	<table align="left" cellpadding="1" width="100%" cellspacing="1" border="0" >
		<tr>
			<td valign="top">
			<table align="left" cellpadding="1" width="100%" cellspacing="1" border="0" >
				<tr height="30">
					<td>
					<div style="float: left">
						<h2 style="color: #795548;font-weight: 900">WordPress to Sugar / SuiteCRM Lead</h2>
					</div>
					<div style="float: right">
						<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=pro'); ?>" class="OEPL_get_pro">Get Pro version</a>
					</div></td>
				</tr>

				<tr>
					<td valign="top" style="">
					<div class="OEPL_tab_settings">
						<ul class="tabs">
							<li class="<?php echo($_GET['view'] == 'sugarSettings' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=sugarSettings'); ?>">Sugar / SuiteCRM Settings</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'generalSettings' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=generalSettings'); ?>">General Settings</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'messageSettings' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=messageSettings'); ?>">Message Settings</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'CustomCSS' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=CustomCSS'); ?>">Custom CSS</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'ShortCode' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=ShortCode'); ?>">Short Code</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'pro' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=pro'); ?>">Pro Features</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'CRMPlugins' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=CRMPlugins'); ?>">Sugar Plugins</a>
							</li>
							<li class="<?php echo($_GET['view'] == 'SuitePlugins' ? 'active' : ''); ?>">
								<a href="<?php echo admin_url('admin.php?page=SugarSetting&view=SuitePlugins'); ?>">SuiteCRM Plugins</a>
							</li>
											
						</ul>
						<div class="content">
							<form name="OEPl_sugarSettings" id="OEPl_sugarSettings" method="post">
								<input type="hidden" id="oepl_nonce" value="<?php echo wp_create_nonce( 'upload_thumb' )?>" name="oepl_nonce" />
								<div class="OEPL_ErrMsg">
									This is Error Message
								</div>
								<div class="OEPL_SuccessMsg">
									This is success message
								</div>

								<table class="form-table" style="clear: none">
									<?php if($_GET['view'] == 'sugarSettings'){
/**************************************
* PLUGIN SUGARCRM API SETTINGS
**************************************/
									?>
									<div class="title">
										<span class="fa fa-gears fa-1x" ></span> Sugar / SuiteCRM REST API Settings
									</div>
									<tr>
									<td><strong>Sugar / SuiteCRM URL :</strong><br />
									<input name="OEPL_SUGARCRM_URL" type="text" id="OEPL_SUGARCRM_URL" value="<?php echo get_option('OEPL_SUGARCRM_URL'); ?>" size="53" required/>
									<p class="description">Your Sugar / SuiteCRM REST API URL will be <Domain>/service/v4_1/rest.php.<br />i.e. http://mycrm.com/service/v4_1/rest.php <b>or</b> http://demo.mycrm.com/service/v4_1/rest.php</p></td>
									</tr>
									<tr>
									<td><strong>SugarCRM Admin User :</strong><br />
									<input name="OEPL_SUGARCRM_ADMIN_USER" autocomplete="off" type="text" id="OEPL_SUGARCRM_ADMIN_USER" value="<?php echo get_option('OEPL_SUGARCRM_ADMIN_USER'); ?>" size="25" required /></td>
									</tr>
									<tr>
									<td><strong>SugarCRM Admin Password : </strong><br />
									<input name="OEPL_SUGARCRM_ADMIN_PASS" autocomplete="off" type="text" id="OEPL_SUGARCRM_ADMIN_PASS" value="" required size="25" /></td>
									</tr>
									<tr>
									<td colspan="2"><strong>Is your SugarCRM .htaccess protected ?</strong>&nbsp;&nbsp;
									<input type="checkbox" name="OEPL_is_htacess_protected" id="OEPL_is_htacess_protected" <?php echo $htacessCbx; ?> /></td>
									</tr>
									<tr class="OEPL_htaccess_tr" style="display: none">
									<td><strong>.htaccess UserName : </strong><br />
									<input type="text" name="Oepl_Htaccess_Admin_User" id="Oepl_Htaccess_Admin_User" value="<?php echo $htaccessUsername; ?>" /></td>
									</tr>
									<tr class="OEPL_htaccess_tr" style="display: none">
									<td><strong>.htaccess Password : </strong><br />
									<input type="text" name="Oepl_Htaccess_Admin_Pass" id="Oepl_Htaccess_Admin_Pass" /></td>
									</tr>
									<tr>
									<td class="OEPL_reload_this"><input type="button" name="testConn" id="testConn" value="Test Connection" class="button button-large" />
									&nbsp;&nbsp;
									<input type="submit" value="<?php _e('Save Changes') ?>" class="button button-primary button-large OEPLsaveConfig" />
									&nbsp;&nbsp;
									<?php if(get_option('OEPL_SUGARCRM_ADMIN_PASS') && get_option('OEPL_SUGARCRM_ADMIN_PASS') != '' ){
									?>
									<input type="button" value="<?php _e('Synchronize Lead Fields') ?>" id="LeadFldSync" class="button button-primary button-large" />
									<?php } ?>
									</td>
									</tr>
									<?php } ?>
									<?php if($_GET['view'] == 'generalSettings'){
/**************************************
* PLUGIN GENERAL SETTINGS
**************************************/
									?>
									<div class="title">
										<span class="fa fa-tachometer fa-1x" style="font-size: 25px"></span> Plugin Genaral Settings
									</div>
									<tr>
										<th>CAPTCHA status :</th>
										<td>
										<select class="captchaSettings" name="captchaSettings">
											<option <?php echo ($captchaSettings == 'Y'? 'selected="selected"' : '') ?> value="Y">Active</option>
											<option <?php echo ($captchaSettings == 'N' || $captchaSettings == FALSE ? 'selected="selected"' : '') ?> value="N">Inactive</option>
										</select>
										<p class="description">
											You can Enable or Disable CAPTCHA on your Lead-Forms anytime you want.
										</p></td>
									</tr>

									<tr>
									<th>Select CAPTCHA :</th>
									<td>
										<select class="oepl_sel_captcha" name="oepl_sel_captcha">
											<option <?php echo ($sel_captcha == 'numeric' || $sel_captcha == FALSE ? 'selected="selected"' : '') ?> value="numeric">Numeric CAPTCHA</option>
											<option <?php echo ($sel_captcha == 'google'? 'selected="selected"' : '') ?> value="google">Google CAPTCHA</option>
										</select>
									<p class="description">
									You can Select Which CAPTCHA you want to use on your Lead-Forms anytime you want.
									</p></td>
									<?php
										$oepl_recaptcha_site_key 	= get_option('OEPL_RECAPTCHA_SITE_KEY');
										$oepl_recaptcha_secret_key 	= get_option('OEPL_RECAPTCHA_SECRET_KEY');	
									?>
										
									<tr class="reCAPTCHA_tr">
									  	<td style="padding: 10px 10px 15px 0 !important;" colspan="2"><strong>Goolge reCAPTCHA settings</strong>
										<p class="description">To use reCAPTCHA, you need to <a href="https://www.google.com/recaptcha/admin#list" target="_blank">sign up for API keys</a> for your site. </p>
										</td>
									</tr>
									<tr class="reCAPTCHA_tr">
										<th><strong>reCAPTCHA Site key (Public key) : </strong></th>
										<td>
											<input type="text" class="oepl_recaptcha_site_key" value="<?php echo $oepl_recaptcha_site_key; ?>" name="oepl_recaptcha_site_key" id="oepl_recaptcha_site_key" />
										</td>
									</tr>
									<tr class="reCAPTCHA_tr">
										<th><strong>reCAPTCHA Secret key (Private key) : </strong></th>
										<td>
											<input type="text" class="oepl_recaptcha_secret_key" value="<?php echo $oepl_recaptcha_secret_key; ?>" name="oepl_recaptcha_secret_key" id="oepl_recaptcha_secret_key" />
										</td>
									</tr>
									</tr>

									<tr>
									<th align="right">Capture Remote IP :</th>
									<td><input type="checkbox" name="IPaddrStatus" value="1" class="IPaddrStatus" <?php echo $IP_checked; ?> />
									<p class="description">If check box is checked then plug-in will pass user's Remote IP Address to your SugarCRM Lead module. <br />
									<div class="OEPL_highlight_this"><strong>To use this feature – you must create a custom field in your SugarCRM Lead module with field-name 'lead_remote_ip'.</div>
									</p></td>
									</tr>

									<tr>
									<th align="right">Get Email Notification :</th>
									<td><input type="checkbox" name="EmailNotification" id="EmailNotification" <?php echo $Email_checked; ?> />
									<p class="description">Receive email notification whenever a new lead is generated.</p></td>
									</tr>

									<tr class="EmailToTR" style="display: none">
										<th align="right">Send Email to :</th>
										<td>
										<input type="text" name="EmailReceiver" size="50" id="EmailReceiver" value="<?php echo $EmailNotificationRx; ?>" />
										<p class="description">
											Provide Email address to which notification will be sent. Multiple recipients may be specified using a comma ( , ) separated string.
										</p></td>
									</tr>

									<tr>
									<th align="right">Redirect after submit :</th>
									<td><input type="checkbox" name="OEPL_redirect_user" id="OEPL_redirect_user" value="" <?php echo $redirectCbx; ?> />
									<p class="description">Redirect user to any page you want after lead is successfully generated.</p></td>
									</tr>

									<tr class="OEPL_redirect_tr" style="display: none">
										<th align="right">Redirect to :</th>
										<td>
										<input type="text" name="OEPL_redirect_user_to" id="OEPL_redirect_user_to" value="<?php echo $redirectTo; ?>" size="50" />
										<p class="description">
											Please enter URL including http://...
											<br />
											<strong>example :</strong> http://www.DomainName.com/
										</p></td>
									</tr>

									<tr height="8"></tr>
									<tr>
									<th></th>
									<td><?php submit_button('Save Settings', 'primary', 'OEPL_save_general_settings', false); ?></td>
									</tr>
									<?php } ?>

									<?php if($_GET['view'] == 'messageSettings'){
									/**************************************
									* PLUGIN MESSAGE SETTINGS
									**************************************/
									?>
									<div class="title">
										<span class="fa fa-comments fa-1x" style="font-size: 25px"></span> Plugin Message Settings
									</div>
									<tr>
										<th>Success Message :</th>
											<td><textarea class="SuccessMessage" cols="40" rows="2" name="SuccessMessage"><?php echo $successMsg; ?></textarea>
											<p class="description">Message to be displayed when lead is successfully generated.</p></td>
									</tr>
									<tr>
										<th>Failure Message :</th>
											<td><textarea cols="40" rows="2" class="FailureMessage" name="FailureMessage"><?php echo $failureMsg; ?></textarea>
											<p class="description">Message to be displayed when plugin cannot submit lead to SugarCRM.</p></td>
									</tr>
									<tr>
										<th>Required Fields Message :</th>
											<td><textarea cols="40" rows="2" class="ReqFieldsMessage" name="ReqFieldsMessage"><?php echo $ReqFieldsMessage; ?></textarea>
											<p class="description">Message to be displayed when user is too lazy to fill in the required fields.</p></td>
									</tr>
									<tr>
										<th>Invalid Captcha Message :</th>
											<td><textarea cols="40" rows="2" class="InvalidCaptchaMessage" name="InvalidCaptchaMessage" ><?php echo $InvalidCaptchaMessage; ?></textarea>
											<p class="description">Message to be displayed when user is so week at math that he cannot do simple addtion of two digits. </p></td>
									</tr>
									<tr>
										<td></td>
											<td><?php submit_button('Save Messages', 'primary', 'OEPL_message_save', false); ?></td>
									</tr>
									<?php } ?>

									<?php if($_GET['view'] == 'CustomCSS'){
									/**************************************
									* PLUGIN CUSTOM CSS SETTINGS
									**************************************/
									?>
									<div class="title">
										<span class="fa fa-pencil-square-o fa-1x" style="font-size: 25px"></span> Custom CSS
									</div>
									<tr>
										<td style="padding: 5px 10px;"><textarea rows="15" style="width: 100%;font-family: Consolas,Monaco,monospace;min-width: 100%;max-width: 100%;border: 1px solid #009688 !important;box-shadow: 0 0 5px #009688 inset !important;" name="OEPL_custom_css" id="OEPL_custom_css" ><?php echo get_option("OEPL_Form_Custom_CSS"); ?></textarea>
										<p class="description">You can write down your custom css here. Be sure to wrap your styles in "&lt;style&gt; &lt;/style&gt;" <br />
										Click here for basic <a onclick="jQuery('#OEPL_form_structure').toggle()" style="cursor: pointer">Form Structure</a></p>
										
										<div id="OEPL_form_structure" style="display: none">
										<xmp style="cursor:copy;border: 1px solid #009688;padding: 10px;box-shadow: 0 0 5px #009688 inset !important;">
											<p>// Form Message will be displayed here
												<div class='LeadFormMsg' style='color:red'></div>
											</p>
		
											<form id="OEPL_Widget_Form" >
												<p>
													<label><strong>LABEL HERE <span style="color: red">*</span> :</strong></label><br>
													<input type="text" id="" name="">
												</p>
			
												<p class="WidgetLeadFormCaptcha">
													<label>What is &nbsp;<strong>8 + 9</strong> ?</label><br>
													<input type="text"  id="captcha" name="">
												</p>
			
												<p>
													<input type="submit" id="WidgetFormSubmit" value="Submit" name="submit">
												</p>
											</form>
											</xmp>
										</div></td>
									</tr>
									
									<tr>
									<td style="padding: 5px 10px;"><?php submit_button('Save Custom CSS', 'primary', 'OEPL_css_save', false); ?></td>
									</tr>
									<?php } ?>

									<?php if($_GET['view'] == 'pro'){
									/**************************************
									* PLUGIN CUSTOM CSS SETTINGS
									**************************************/
									?>
									<div class="title">
										<span class="fa fa-bolt fa-1x" style="font-size: 25px"></span> Wordpress to Sugar and SuiteCRM form builder PRO
									</div>
									<p>
										Thank you for using our Plugin. It's always nice to have more on your plate. Our PRO edition will help you to <strong>generate unlimited web-forms</strong> in few simple steps via user friendly drag & drop designed based form-builder.
									</p>
									<p>If you didn't know then let me tell you that our plugin is also compitible with <strong>SuiteCRM.</strong></p>
									<h4 class="OEPL_highlight_this OEPL-red" style="margin: 0px !important">Pro Version Features :</h4>
									<ul style="list-style:inside;margin-left: 10px;line-height: 1.6">
										<li>
											User-friendly Drag & Drop form builder.
										</li>
										<li>
											Option to use Custom CAPTCHA method or google reCAPTCHA on your Lead-Forms.
										</li>
										<li>
											Create multiple forms and use Shortcode generated anywhere on your WordPress site.
										</li>
										<li>
											Unlimited Forms with different set of fields.
										</li>
										<li>
											Additional email notification option for each form.
										</li>
										<li>
											Generate Short-Code to set form anywhere in your WordPress website.
										</li>
										<li>
											Email compose feature to send auto reply to visitors for individual forms. You can use Lead-Form fields in WYSIWYG editor to compose email template.
										</li>
										<li>
											Get premium support.
										</li>
									</ul>
									<hr />
									<p><a class="OEPL-link" href="https://www.youtube.com/watch?feature=player_embedded&v=Ue8XFqC6bnM" target="_blank">Click Here</a> for detailed video walk through of our <strong>'Wordpress to SugarCRM form builder PRO'.</strong></p>
									<p><a class="OEPL-link" href="http://www.offshoreevolution.com/wordpress-sugar-integration.html" target="_blank">Click Here</a> to submit your inquiry to get PRO plugin and more detail about it.</p>
									<?php } ?>

									<?php if($_GET['view'] == 'ShortCode'){
									/**************************************
									* PLUGIN CUSTOM CSS SETTINGS
									**************************************/
									?>
									<div class="title">
										<span class="fa fa-bolt fa-1x" style="font-size: 25px"></span> Shor Code
									</div>
									<h3>[OEPL_CRM_Lead_Form]</h3>					
									<?php } ?>

									<?php if($_GET['view'] == 'CRMPlugins') { ?>
									<div class="title">
										<span class="fa fa-bolt fa-1x" style="font-size: 25px"></span> Our Sugar Plugins
									</div>

									<span class="fa-1x" style="font-size: 25px"><a href="http://www.offshoreevolution.com/scan-identical-leads.html" target="_blank">Scan Identical Leads</a> <span class="blink3oDays">Free 30 day trial</span></span>
									<div class="PluginDesc">
										Have newly created leads? Processing imported leads from one or more sources? Quickly identify if there is already an existing lead by setting up your predefined parameters. Any possible duplicates will be highlighted and noted when viewing a given lead.
									</div>
									<br />
									<br />
									<span class="fa-1x" style="font-size: 25px"><a href="http://www.offshoreevolution.com/proximity-module.html" target="_blank">Proximity Search</a> <span class="blink3oDays">Free 30 day trial</span></span>
									<div class="PluginDesc">
										Proximity searches are becoming more essential to businesses every day. Sales and marketing teams use them to organize field visits and campaigns. The real estate industry use them to offer better alternative locations to their customers. Hotel, travel and tourism businesses use them to offer various accommodation options and places to visit. How will you use it?
									</div>

									<br />
									<?php } ?>

									<?php if($_GET['view'] == 'SuitePlugins') { ?>
									<div class="title">
										<span class="fa fa-bolt fa-1x" style="font-size: 25px"></span> Our SuiteCRM Plugins
									</div>

									<span class="fa-1x" style="font-size: 25px"><a href="http://www.offshoreevolution.com/scan-identical-leads.html" target="_blank">Scan Identical Leads</a> <span class="blink3oDays">Free 30 day trial</span></span>
									<div class="PluginDesc">
										Have newly created leads? Processing imported leads from one or more sources? Quickly identify if there is already an existing lead by setting up your predefined parameters. Any possible duplicates will be highlighted and noted when viewing a given lead.
									</div>
									<br /><br />
									<span class="fa-1x" style="font-size: 25px"><a href="http://www.offshoreevolution.com/proximity-module.html" target="_blank">Proximity Search</a> <span class="blink3oDays">Free 30 day trial</span></span>
									<div class="PluginDesc">
										Proximity searches are becoming more essential to businesses every day. Sales and marketing teams use them to organize field visits and campaigns. The real estate industry use them to offer better alternative locations to their customers. Hotel, travel and tourism businesses use them to offer various accommodation options and places to visit. How will you use it?
									</div>

									<br />
									<?php } ?>
									
						</table></form>
						</div>
					</div></td>
				</tr>
			</table></td>
		</tr>
	</table>
</div>